C LaTeX Driver
      SUBROUTINE LXDRIV(OPCODE,RBUF,NBUF,CHR,LCHR)
C This is a driver for LaTeX's 'picture' environment.
C It generates plots in a 6"x6" window (which corresponds to
C 1728x1728 units where a unit is 0.25pt and there are 72/0.25 units
C per inch). For some graphs (especially with a lot of shaded areas),
C the capacity of many LaTeX systems can easily be exceeded. Lower resolution
C is one possible solution (e.g. 432x432 at 1pt and 72 units/inch).
C
C Written by Grant McIntosh  95/02/14
C Email: gmcint@relay.drev.dnd.ca
C
      INTEGER OPCODE
      REAL RBUF(*)
      INTEGER NBUF
      CHARACTER*(*) CHR
      INTEGER LCHR
      INTEGER LUN, IXO, IYO, IXPS, IYPS, I, J
      INTEGER INCR, NINC, IER, ISIGN, LENGTH
      INTEGER GROPTX
      REAL X1, Y1, X2, Y2, DELX, DELY, SLOPE
      CHARACTER*128 MSG
      CHARACTER*(*) DEVNAM
      PARAMETER (DEVNAM='LATEX (LaTeX picture environment)')
      CHARACTER*1   BS
      SAVE LUN
      DATA          BS/92/
C-----------------------------------------------------------------------
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,140,150)OPCODE
      NBUF=-1
      RETURN
C-----------------------------------------------------------------------
   10 CHR=DEVNAM
      LCHR=LEN(DEVNAM)
      RETURN
C-----------------------------------------------------------------------
   20 RBUF(1)=0
      RBUF(2)=1728
      RBUF(3)=0
      RBUF(4)=1728
      RBUF(5)=0
      RBUF(6)=1
      RETURN
C-----------------------------------------------------------------------
   30 RBUF(1)=72./0.25
      RBUF(2)=72./0.25
      RBUF(3)=1.
      RETURN
C-----------------------------------------------------------------------
   40 CHR='HNNNNNNNNN'
      RETURN
C-----------------------------------------------------------------------
   50 CHR='pgplot.tex'
      LCHR=10
      RETURN
C-----------------------------------------------------------------------
   60 RBUF(1)=0
      RBUF(2)=1728
      RBUF(3)=0
      RBUF(4)=1728
      RETURN
C-----------------------------------------------------------------------
   70 RBUF(1)=1
      RETURN
C-----------------------------------------------------------------------
   80 RETURN
C-----------------------------------------------------------------------
   90 CALL GRGLUN(LUN)
      IER = GROPTX(LUN, CHR(1:LCHR), 'pgplot.tex', 1)
      IF (IER.NE.0) THEN
         MSG = 'Cannot open output file for LaTeX picture: '//
     :         CHR(:LCHR)
         CALL GRWARN(MSG)
         RBUF(1)=0
         RBUF(2)=0
         CALL GRFLUN(LUN)
      ELSE
         RBUF(2)=1
         RBUF(1)=LUN
      END IF
      NBUF=2
      RETURN
C-----------------------------------------------------------------------
  100 CLOSE(UNIT=LUN)
      CALL GRFLUN(LUN)
      RETURN
C-----------------------------------------------------------------------
  110 WRITE(LUN,'(A)') BS//'setlength{'//BS//'unitlength}{0.25pt}'
      WRITE(LUN,'(A)') BS//'linethickness{1pt}'
      WRITE(LUN,'(A)') BS//'begin{picture}(1728,1728)(0,0)'
      RETURN
C-----------------------------------------------------------------------
C DRAW A LINE FROM X1,Y1 TO X2,Y2
  120 X1=RBUF(1)
      Y1=RBUF(2)
      X2=RBUF(3)
      Y2=RBUF(4)
      IXO=X1
      IYO=Y1
      IXPS=X2
      IYPS=Y2
C vertical lines
      IF(IXPS.EQ.IXO) THEN
      LENGTH=ABS(IYPS-IYO)
      ISIGN=1
      IF(LENGTH.NE.0) ISIGN=(IYPS-IYO)/LENGTH
      WRITE(LUN,5000) BS,IXO,IYO,BS,ISIGN,LENGTH
 5000 FORMAT(A1,'put(',I4,',',I4,'){',A1,'line(0,',I4,'){',I4,'}}')
      RETURN
      ENDIF
C horizontal lines
      IF(IYPS.EQ.IYO) THEN
      LENGTH=ABS(IXPS-IXO)
      ISIGN=1
      IF(LENGTH.NE.0) ISIGN=(IXPS-IXO)/LENGTH
      WRITE(LUN,5100) BS,IXO,IYO,BS,ISIGN,LENGTH
 5100 FORMAT(A1,'put(',I4,',',I4,'){',A1,'line(',I4,',0){',I4,'}}')
      RETURN
      ENDIF
C other lines
      SLOPE=FLOAT(IYPS-IYO)/FLOAT(IXPS-IXO)
      INCR=1
      IF(IXPS.LT.IXO) INCR=-1
      NINC=MAX(1,ABS(IXPS-IXO))
      DELX=INCR
      DELY=SLOPE*INCR
  130 CONTINUE
      IF(ABS(DELY).GT.1) THEN
      NINC=NINC*2
      DELX=DELX/2.
      DELY=SLOPE*DELX
      GOTO 130
      ENDIF
      WRITE(LUN,5200) BS,IXO,IYO,DELX,DELY,NINC,BS
 5200 FORMAT(A1,'multiput(',I4,',',I4,')(',F8.3,',',F8.3,'){',I4,
     *'}{',A1,'circle*{1}}')
      RETURN
C-----------------------------------------------------------------------
  140 I=NINT(RBUF(1))
      J=NINT(RBUF(2))
      WRITE(LUN,5300) BS,I,J,BS
 5300 FORMAT(A1,'put(',I4,',',I4,'){',A1,'circle*{1}}')
      RETURN
C-----------------------------------------------------------------------
  150 WRITE(LUN,'(A)') BS//'end{picture}'
      RETURN
C-----------------------------------------------------------------------
      END
